----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:52:59 01/02/2009 
-- Design Name: 
-- Module Name:    LRB_link - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,MYLIB;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use mylib.dcc_pack.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity LRB_link is
		generic (sim : boolean := false);
    Port ( 
           TCLKin : in  STD_LOGIC;
           TD_P : in  STD_LOGIC_VECTOR (8 downto 0);
           TD_n : in  STD_LOGIC_VECTOR (8 downto 0);
           polarity : in  STD_LOGIC_VECTOR (11 downto 0);-- bit 11 for rCLK, bit 10 for RD, bit 9 for TCLK, bit 8-0 for TD
           rCLK_P : out  STD_LOGIC;
           rCLK_n : out  STD_LOGIC;
           RD_P : out  STD_LOGIC;
           RD_n : out  STD_LOGIC;
					 clk : in  STD_LOGIC;
           clk180 : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           run : in  STD_LOGIC;
           n_strobe : in  STD_LOGIC;
					 update_led : in  STD_LOGIC;
           vme_cycle : in  STD_LOGIC;
           addr_str : in  STD_LOGIC;
           vme_read : in  STD_LOGIC;
           rd_length: in  STD_LOGIC_VECTOR (3 downto 0);
           LRB_ID: in  STD_LOGIC_VECTOR (2 downto 0);
           LRB_en: in  STD_LOGIC_VECTOR (2 downto 0);
           led : in  STD_LOGIC_VECTOR (4 downto 0);
           addr : in  STD_LOGIC_VECTOR (15 downto 0);
           we_byte : in  STD_LOGIC_VECTOR (3 downto 0);
           w_data : in  STD_LOGIC_VECTOR (31 downto 0);
           lrb_test : in  STD_LOGIC;
           lrb_test_str : in  STD_LOGIC;
           lrb_test_data : in  STD_LOGIC_VECTOR (31 downto 0);  
           test_ack : out  STD_LOGIC;
           LRB_ack : out  STD_LOGIC;
           event_data_str : in  STD_LOGIC;
           event_data_req : in  STD_LOGIC_VECTOR (18 downto 0);-- bit 18-17 CH number, bit 16-9 = buffer number, bit 8-0 = word count - 1  
           re_event_info : in  STD_LOGIC;
           re_event_data : in  STD_LOGIC;
           reg_data_dav : out  STD_LOGIC;
           debug : out  STD_LOGIC_VECTOR (31 downto 0);-- output all '0' when not selected
           reg_data : out  STD_LOGIC_VECTOR (31 downto 0);-- output all '0' when not selected
           event_info_rdy : out  STD_LOGIC;
           event_info_val : out  STD_LOGIC;
           event_info : out  STD_LOGIC_VECTOR (32 downto 0);-- output all '0' when not selected
           event_data_rdy : out  STD_LOGIC;
           event_data : out  STD_LOGIC_VECTOR (32 downto 0));-- output all '0' when not selected
end LRB_link;

architecture Behavioral of LRB_link is
signal strobe : std_logic := '0';
signal tclk : std_logic := '0';
signal tclkn : std_logic := '0';
--signal clkn : std_logic := '0';
signal td : std_logic_vector(8 downto 0) := (others => '0');
signal rd : std_logic := '0';
signal rclk : std_logic := '0';
signal td_in : std_logic_vector(17 downto 0) := (others => '0');
signal d_in : std_logic_vector(35 downto 0) := (others => '0');
signal d_out : std_logic_vector(1 downto 0) := (others => '0');
signal t_valid : std_logic := '0';
signal we_event_data : std_logic := '0';
signal we_event_info : std_logic := '0';
signal we_reg_data : std_logic := '0';
--signal reg_flag : std_logic := '0';
signal reg_data_wa : std_logic_vector(3 downto 0) := (others => '0');
signal reg_data_wa_sync : std_logic_vector(1 downto 0) := (others => '0');
signal reg_data_wa_sync2 : std_logic_vector(1 downto 0) := (others => '0');
signal reg_data_ra : std_logic_vector(3 downto 0) := (others => '0');
signal reg_datap : std_logic_vector(31 downto 0) := (others => '0');
signal fifo_din : std_logic_vector(35 downto 0) := (others => '0');
signal data_fifo_do : std_logic_vector(35 downto 0) := (others => '0');
signal info_fifo_do : std_logic_vector(35 downto 0) := (others => '0');
signal data_fifo_wa : std_logic_vector(9 downto 0) := (others => '0');
signal data_fifo_ra : std_logic_vector(9 downto 0) := (others => '0');
signal info_fifo_wa : std_logic_vector(8 downto 0) := (others => '0');
signal info_fifo_ra : std_logic_vector(8 downto 0) := (others => '0');
signal data_wa0_sync : std_logic_vector(2 downto 0) := (others => '0');
signal info_wa0_sync : std_logic_vector(2 downto 0) := (others => '0');
signal data_fifo_wc : std_logic_vector(9 downto 0) := (others => '0');
signal info_fifo_wc : std_logic_vector(8 downto 0) := (others => '0');
signal data_fifo_afull : std_logic := '0';
signal data_fifo_afull_q : std_logic := '0';
signal ec_info_fifo_ra : std_logic := '0';
signal event_header : std_logic := '0';
signal event_end_flag : std_logic := '0';
signal lrb_test_q : std_logic := '0';
signal lrb_en_q : std_logic_vector(2 downto 0) := (others => '0');
signal ee_flag_sync : std_logic_vector(2 downto 0) := (others => '0');
signal event_cnt : std_logic_vector(3 downto 0) := (others => '0');
signal sr : std_logic_vector(33 downto 0) := (others => '0');
signal get_event : std_logic_vector(18 downto 0) := (others => '0');
signal tx_idle : std_logic := '0';
signal new_led : std_logic_vector(4 downto 0) := (others => '0');
signal d_rclk : std_logic_vector(1 downto 0) := (others => '0');
signal run_q : std_logic := '0';
signal status_rqst : std_logic := '0';
signal reset_flag : std_logic := '0';
signal led_flag : std_logic := '0';
signal vme_rqst : std_logic := '0';
signal send_cmd : std_logic := '0';
signal send_cmd_dl : std_logic := '0';
signal cmd_cntr : std_logic_vector(4 downto 0) := (others => '0');
signal init_cmd_cntr : std_logic_vector(3 downto 0) := (others => '0');
signal vme_cmd : std_logic_vector(32 downto 0) := (others => '0');
signal sel_cmd : std_logic_vector(1 downto 0) := (others => '0');
signal en_rx : std_logic := '0';
--signal we_event_que : std_logic := '0';
signal rd_event_que : std_logic := '0';
signal event_que_dav : std_logic := '0';
type init_array is array(3 downto 0) of bit_vector(15 downto 0);
constant init_value : init_array := (x"000d",x"0004",x"00f1",x"00f0");
attribute INIT : string;
attribute INIT of event_header : signal is "S";
attribute INIT of en_rx : signal is "R";
begin
-- receving from LRB
tclk <= TCLKin when sim or polarity(9) = '0' else not TCLKin; 
tclkn <= not tclk; 
g_td_in: for i in 0 to 8 generate
  i_td: ibufds generic map(DIFF_TERM => TRUE,IOSTANDARD => "LVDS_33") port map(i => td_p(i), ib => td_n(i), o => tD(i));
	i_tdddr : IDDR2
		generic map(DDR_ALIGNMENT => "C0")
		port map (
      Q0 => td_in(i), -- 1-bit output captured with C0 clock
      Q1 => td_in(9+i), -- 1-bit output captured with C1 clock
      C0 => tCLK, -- 1-bit clock input
      C1 => tCLKn, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D => TD(i),   -- 1-bit data input 
      R => '0',    -- 1-bit reset input
      S => '0'     -- 1-bit set input
		);
end generate;
process(tclk)
begin
  if(tclk'event and tclk = '1')then
		if(sim)then
			d_in(17 downto 0) <= td_in(17 downto 0);
		else
			d_in(17 downto 0) <= (polarity(8 downto 0) xor td_in(17 downto 9)) & (polarity(8 downto 0) xor td_in(8 downto 0));
		end if;
    d_in(35 downto 18) <= d_in(17 downto 0);
		if(t_valid = '1' or en_rx = '0')then
			t_valid <= '0';
			we_event_data <= '0';
			we_event_info <= '0';
			we_reg_data <= '0';
		elsif(d_in(17) = '1')then
			t_valid <= '1';
			case d_in(16 downto 15) is
				when "00" => we_event_data <= '1';
				when "01" => we_event_info <= '1';
				when others => we_reg_data <= '1';
			end case;
		end if;
  end if;
end process;
i_reg_data: ram16XNd generic map( N => 32)
    port map(
        clk => tclk,
        we	=> we_reg_data,
        d		=> d_in(31 downto 0),
        a		=> reg_data_wa,
        dpra=> reg_data_ra,
        dpo	=> reg_datap
    );
process(tclk,reset)
begin
	if(reset = '1')then
		reg_data_wa <= x"0";
		event_end_flag <= '0';
		data_fifo_wa <= (others => '0');
		info_fifo_wa <= (others => '0');
  elsif(tclk'event and tclk = '1')then
		if(we_reg_data = '1')then
			reg_data_wa(1 downto 0) <= reg_data_wa(0) & not reg_data_wa(1);
		end if;
		if(we_event_data = '1')then
			event_end_flag <= event_end_flag xor d_in(32);
		end if;
		if(we_event_data = '1')then
			data_fifo_wa <= data_fifo_wa + 1;
		end if;
		if(we_event_info = '1')then
			info_fifo_wa <= info_fifo_wa + 1;
		end if;
  end if;
end process;
fifo_din <= "000" & d_in(32 downto 0);
event_data <= data_fifo_do(32 downto 0);
g_fifo: for i in 0 to 1 generate
  i_data_fifo : RAMB16_s18_s18
   generic map (
      SIM_COLLISION_CHECK => "NONE") -- "NONE", "WARNING", "GENERATE_X_ONLY", "ALL" 
   port map (
      DOB => data_fifo_do(18*i+15 downto 18*i),      -- Port B 16-bit Data Output
      DOPB => data_fifo_do(18*i+17 downto 18*i+16),    -- Port B 2-bit Parity Output
      ADDRA => data_fifo_wa,  -- 10-bit A port Address Input
      ADDRB => data_fifo_ra,  -- 10-bit A port Address Input
      CLKA => tclk,    -- Port A Clock
      CLKB => clk,    -- Port B Clock
      DIA => fifo_din(18*i+15 downto 18*i),      -- Port A 16-bit Data Input
      DIB => x"0000",      -- Port B 16-bit Data Input
      DIPA => fifo_din(18*i+17 downto 18*i+16),    -- Port A 2-bit parity Input
      DIPB => "00",    -- Port-B 2-bit parity Input
      ENA => we_event_data,      -- Port A RAM Enable Input
      ENB => '1',      -- PortB RAM Enable Input
      SSRA => '0',    -- Port A Reset Input
      SSRB => not re_event_data,    -- Port B Reset Input
      WEA => '1',      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
end generate;
event_info <= info_fifo_do(32 downto 0);
i_info_fifo : RAMB16_s36_s36
   generic map (
      SIM_COLLISION_CHECK => "NONE") -- "NONE", "WARNING", "GENERATE_X_ONLY", "ALL" 
   port map (
      DOB => info_fifo_do(31 downto 0),      -- Port B 32-bit Data Output
      DOPB => info_fifo_do(35 downto 32),    -- Port B 4-bit Parity Output
      ADDRA => info_fifo_wa,  -- 9-bit A port Address Input
      ADDRB => info_fifo_ra,  -- 9-bit A port Address Input
      CLKA => tclk,    -- Port A Clock
      CLKB => clk,    -- Port B Clock
      DIA => fifo_din(31 downto 0),      -- Port A 32-bit Data Input
      DIB => x"00000000",      -- Port B 32-bit Data Input
      DIPA => fifo_din(35 downto 32),    -- Port A 4-bit parity Input
      DIPB => x"0",    -- Port-B 4-bit parity Input
      ENA => we_event_info,      -- Port A RAM Enable Input
      ENB => '1',      -- PortB RAM Enable Input
      SSRA => '0',    -- Port A Reset Input
      SSRB => not ec_info_fifo_ra,    -- Port B Reset Input
      WEA => '1',      -- Port A Write Enable Input
      WEB => '0'       -- Port B Write Enable Input
   );
i_rd : OBUFDS generic map(IOSTANDARD => "LVDS_33") port map (O => rd_p, OB => rd_n, I => rd);
i_rdddr : ODDR2
		generic map(DDR_ALIGNMENT => "C0")
		port map (
      Q => rd, -- 1-bit output data
      C0 => clk, -- 1-bit clock input
      C1 => clk180, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D0 => d_out(1),   -- 1-bit data input (associated with C0)
      D1 => d_out(0),   -- 1-bit data input (associated with C1)
      R => '0',    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
i_rclk : OBUFDS generic map(IOSTANDARD => "LVDS_33") port map (O => rclk_p, OB => rclk_n, I => rclk);
i_rclkddr : ODDR2
		port map (
      Q => rclk, -- 1-bit output data
      C0 => clk180, -- 1-bit clock input
      C1 => clk, -- 1-bit clock input
      CE => '1',  -- 1-bit clock enable input
      D0 => d_rclk(0),   -- 1-bit data input (associated with C0)
      D1 => d_rclk(1),   -- 1-bit data input (associated with C1)
      R => '0',    -- 1-bit reset input
      S => '0'     -- 1-bit set input
   );
d_rclk(0) <= '1' when sim else not polarity(11);
d_rclk(1) <= not d_rclk(0);
d_out <= sr(33 downto 32) when sim or polarity(10) = '0' else not sr(33 downto 32);
process(clk)
begin
  if(clk'event and clk = '1')then
    strobe <= n_strobe and not strobe;
		if(strobe = '1')then	
			reg_data_wa_sync <= reg_data_wa(1 downto 0);
			reg_data_wa_sync2 <= reg_data_wa_sync;
			reg_data <= reg_datap;
			if(addr(14 downto 13) = LRB0_base_addr(16 downto 15) and LRB_ID = addr(12 downto 10))then
				reg_data_ra(3) <= '0';
			else
				reg_data_ra(3) <= '1';
			end if;
			if(reset = '1' or lrb_test = '1')then
				reg_data_dav <= '0';
			elsif(reg_data_wa_sync2 /= reg_data_ra(1 downto 0) or (send_cmd = '1' and sel_cmd(1) = '0' and vme_cmd(32) = '1'))then
				reg_data_dav <= '1';
			else
				reg_data_dav <= '0';
			end if;
			if(reset = '1')then
				reg_data_ra(2 downto 0) <= "000";
			elsif(reg_data_wa_sync2 /= reg_data_ra(1 downto 0))then
				reg_data_ra(1 downto 0) <= reg_data_ra(0) & not reg_data_ra(1);
			end if;
			if(addr(14 downto 9) = ll0_dbg_addr(16 downto 11) and addr(8 downto 6) = lrb_id)then
				debug <= event_header & event_end_flag & event_cnt & data_fifo_wc(5 downto 0) & data_fifo_wa & data_fifo_ra; 
			else
				debug <= (others => '0'); 
			end if;
			if(sim)then
				en_rx <= '1';
			else
				en_rx <= en_rx or update_led;
			end if;
			run_q <= run and not lrb_test;
			if(lrb_test = '1')then
				lrb_en_q <= "000";
			else
				lrb_en_q <= lrb_en;
			end if;
		end if;
		if(tx_idle = '1')then
			sel_cmd(1) <= event_que_dav or status_rqst;
			sel_cmd(0) <= not status_rqst and event_que_dav;
		end if;
		if(tx_idle = '1' or cmd_cntr(4) = '1')then
			cmd_cntr <= (others => '0');
		elsif(send_cmd_dl = '1')then
			cmd_cntr <= '0' & init_cmd_cntr;
		else
			cmd_cntr <= cmd_cntr + 1;
		end if;
		if(cmd_cntr(4) = '1')then
			tx_idle <= '1';
		elsif(n_strobe = '1' and (vme_rqst = '1' or event_que_dav = '1' or status_rqst = '1'))then
			tx_idle <= '0';
		end if;
		if(tx_idle = '0')then
			send_cmd <= '0';
		elsif(n_strobe = '1' and (vme_rqst = '1' or event_que_dav = '1' or status_rqst = '1'))then
			send_cmd <= '1';
		end if;
		send_cmd_dl <= send_cmd;
		if(send_cmd = '1')then
			case sel_cmd is
				when "11" => sr <= x"b" & get_event & "000" & x"00";
				when "10" => sr <= x"a" & data_fifo_afull & reset_flag & run_q & new_led & lrb_en_q & "000" & x"0000";
				when others => sr <= '1' & vme_cmd;
			end case;
		else
			sr <= sr(31 downto 0) & "00";
		end if;
		data_fifo_afull_q <= data_fifo_afull;
		if(send_cmd = '1' and sel_cmd = "10")then
			status_rqst <= '0';
		elsif(data_fifo_afull_q /= data_fifo_afull or reset_flag = '1' or led_flag = '1' or
					(lrb_test = '0' and (run_q /= run or lrb_en /= lrb_en_q)))then
			status_rqst <= '1';
		end if;
		if(data_fifo_wc(9) = '0')then
			data_fifo_afull <= '0';
		elsif(data_fifo_wc(8 downto 7) = "11")then
			data_fifo_afull <= '1';
		elsif(data_fifo_wc(6) = '0')then
			data_fifo_afull <= '0';
		end if;
		if(strobe = '1')then
			if(update_led = '1')then
				new_led <= led;
			end if;
			if(update_led = '1')then
				led_flag <= '1';
			elsif(send_cmd = '1' and sel_cmd = "10")then
				led_flag <= '0';
			end if;
			lrb_test_q <= lrb_test;
			if(reset = '1' or (lrb_test = '1' and lrb_test_q = '0'))then
				reset_flag <= '1';
			elsif(send_cmd = '1' and sel_cmd = "10")then
				reset_flag <= '0';
			end if;
			if(send_cmd = '1' and sel_cmd(1) = '0')then
				vme_rqst <= '0'; 
			elsif(lrb_test = '1')then
				if(lrb_test_str = '1')then
					vme_rqst <= '1'; 
				end if;
			elsif((addr_str = '1' or we_byte /= x"0") and addr(14) = '1' and LRB_ID = addr(12 downto 10))then
				vme_rqst <= '1'; 
			end if;
			if(lrb_test = '1')then
				if(lrb_test_str = '1')then
					vme_cmd <= '1' & lrb_test_data;
				end if;
			elsif(addr_str = '1')then
				vme_cmd <= "000" & vme_cycle & vme_read & rd_length & addr(9 downto 0) & "00" & x"000";
			elsif(we_byte /= x"0")then
				vme_cmd <= '1' & w_data;
			end if;
			if(send_cmd = '1' and sel_cmd(1) = '0' and lrb_test = '0')then
				LRB_ack <= '1';
			else
				LRB_ack <= '0';
			end if;
			if(send_cmd = '1' and sel_cmd(1) = '0' and lrb_test = '1')then
				test_ack <= '1';
			else
				test_ack <= '0';
			end if;
		end if;
		if(reset = '1' and strobe = '1')then
			data_fifo_ra <= (others => '0');
		elsif(re_event_data = '1')then
			data_fifo_ra <= data_fifo_ra + 1;
		end if;
		if(reset = '1' and strobe = '1')then
			info_fifo_ra <= (others => '0');
		elsif(ec_info_fifo_ra = '1')then
			info_fifo_ra <= info_fifo_ra + 1;
		end if;
		if(reset = '1' and strobe = '1')then
			data_wa0_sync <= "000";
		else
			data_wa0_sync <= data_wa0_sync(1 downto 0) & data_fifo_wa(0);
		end if;
		if(reset = '1' and strobe = '1')then
			data_fifo_wc <= (others => '0');
		elsif((data_wa0_sync(2) xor data_wa0_sync(1)) /= re_event_data)then
			if(re_event_data = '1')then
				data_fifo_wc <= data_fifo_wc - 1;
			else
				data_fifo_wc <= data_fifo_wc + 1;
			end if;
		end if;
		if(reset = '1' and strobe = '1')then
			info_wa0_sync <= "000";
		else
			info_wa0_sync <= info_wa0_sync(1 downto 0) & info_fifo_wa(0);
		end if;
		if(reset = '1' and strobe = '1')then
			info_fifo_wc <= (others => '0');
		elsif((info_wa0_sync(2) xor info_wa0_sync(1)) /= ec_info_fifo_ra)then
			if(ec_info_fifo_ra = '1')then
				info_fifo_wc <= info_fifo_wc - 1;
			else
				info_fifo_wc <= info_fifo_wc + 1;
			end if;
		end if;
		if(reset = '1' and strobe = '1')then
			ec_info_fifo_ra <= '0';
		elsif(re_event_info = '1')then
			ec_info_fifo_ra <= '1';
		elsif(or_reduce(info_fifo_wc(8 downto 1)) = '0' and (info_fifo_wc(0) = '0' or ec_info_fifo_ra = '1'))then
			ec_info_fifo_ra <= '0';
		end if;
		event_info_val <= ec_info_fifo_ra and not reset;
		if((reset = '1' and strobe = '1') or ec_info_fifo_ra = '1')then
			event_info_rdy <= '0';
		elsif(or_reduce(info_fifo_wc) = '1')then
			event_info_rdy <= '1';
		end if;
		if(reset = '1' and strobe = '1')then
			ee_flag_sync <= "000";
		else
			ee_flag_sync <= ee_flag_sync(1 downto 0) & event_end_flag;
		end if;
		if((reset = '1' and strobe = '1') or data_fifo_do(32) = '1')then
			event_header <= '1';
		elsif(re_event_data = '1')then
			event_header <= '0';
		end if;
		if(reset = '1' and strobe = '1')then
			event_cnt <= (others => '0');
		elsif((ee_flag_sync(2) xor ee_flag_sync(1)) /= (re_event_data and event_header))then
			if(re_event_data = '1' and event_header = '1')then
				event_cnt <= event_cnt - 1;
			else
				event_cnt <= event_cnt + 1;
			end if;
		end if;
		if(reset = '1' and strobe = '1')then
			event_data_rdy <= '0';
		elsif(or_reduce(event_cnt) = '1')then
			event_data_rdy <= '1';
		else
			event_data_rdy <= '0';
		end if;
		rd_event_que <= send_cmd and sel_cmd(1) and sel_cmd(0);
  end if;
end process;
i_event_que: srl_fifo generic map (N=> 19) PORT MAP(
		rst => reset,
		din => event_data_req,
		w_strobe => strobe,
		we => event_data_str,
		clk => clk,
		r_strobe => '1',
		re => rd_event_que,
		dav => event_que_dav,
		dout => get_event
	);
g_init_cmd_cntr: for i in 0 to 3 generate
	i_init_cmd_cntr : ROM16X1
   generic map (
      INIT => init_value(i))
   port map (
      O => init_cmd_cntr(i),   -- ROM output
      A0 => sr(30), -- ROM address[0]
      A1 => sr(31), -- ROM address[1]
      A2 => sr(32), -- ROM address[2]
      A3 => '0'  -- ROM address[3]
   );
end generate;
end Behavioral;

