--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   13:58:43 08/26/2008
-- Design Name:   
-- Module Name:   C:/iseproj/VME_dcc/u2/lvds_tb.vhd
-- Project Name:  u2
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: LVDS
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY lvds_tb IS
END lvds_tb;
 
ARCHITECTURE behavior OF lvds_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
COMPONENT LVDS
	PORT(
		l_clk : IN std_logic;
		l_strobe : IN std_logic;
		strobe : IN std_logic;
		clk : IN std_logic;
		hq : IN std_logic_vector(19 downto 0);
		cc_rst : IN std_logic;
		ch_number : IN std_logic_vector(4 downto 0);
		lfifo_ack : IN std_logic;          
		lfifo_req : OUT std_logic;
		lfifo_we : OUT std_logic;
		lfifo_data : OUT std_logic_vector(32 downto 0);
		UERR : OUT std_logic;
		CERR : OUT std_logic
		);
end component;    

   --Inputs
   signal l_clk : std_logic := '0';
   signal l_strobe : std_logic := '0';
   signal strobe : std_logic := '0';
   signal clk : std_logic := '0';
   signal hq : std_logic_vector(19 downto 0) := (others => '0');
   signal cc_rst : std_logic := '0';
   signal gc_block : std_logic := '1';
   signal gc_tstrip : std_logic := '0';
   signal gc_idmatch : std_logic := '1';
   signal gc_automon : std_logic := '1';
   signal ch_number : std_logic_vector(4 downto 0) := (others => '0');
   signal lfifo_ack : std_logic := '0';

 	--Outputs
   signal trailer : std_logic;
   signal lfifo_req : std_logic;
   signal lfifo_we : std_logic;
   signal lfifo_data : std_logic_vector(32 downto 0);
   signal update : std_logic;
   signal BADID : std_logic;
   signal UERR : std_logic;
   signal CERR : std_logic;

   -- Clock period definitions
   constant l_clk_period : time := 3.57ns;
   constant clk_period : time := 6.666ns;
 
signal div : std_logic_vector(2 downto 0) := (others => '0');
signal cntr : std_logic_vector(15 downto 0) := (others => '0');
signal cntrb : std_logic_vector(15 downto 0) := (others => '0');
signal last_one : std_logic_vector(15 downto 0) := x"003b";
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: LVDS PORT MAP (
          l_clk => l_clk,
					l_strobe => l_strobe,
					strobe => strobe,
          clk => clk,
          hq => hq,
          cc_rst => cc_rst,
          ch_number => ch_number,
          lfifo_ack => lfifo_ack,
          lfifo_req => lfifo_req,
          lfifo_we => lfifo_we,
          lfifo_data => lfifo_data,
          UERR => UERR,
          CERR => CERR
        );

   -- Clock process definitions
   l_clk_process :process
   begin
		l_clk <= '0';
		wait for l_clk_period/2;
		l_clk <= '1';
		wait for l_clk_period/2;
   end process;
 
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
hq(17 downto 16) <= "00" when cntr < x"0020"  or (cntr > last_one and cntr < x"0040") or cntr > x"0050" else "11" when cntr = x"0020" or cntr = x"0040" else
						 "10" when cntr < last_one or (cntr > x"0040" and cntr < x"0050") else "01";
hq(15 downto 0) <= x"0000" when cntr < x"0020" else x"1c04" when cntr = x"0020" else
						 cntr when cntr < last_one-1 or (cntr > last_one and cntr < x"0050") else x"000d" when cntr = last_one-1 else x"043c";
hq(19 downto 18) <= "00";
lfifo_ack <= '1' when lfifo_req = '1' else '0';
process(clk)
begin
  if(clk'event and clk = '1')then
	 if(cntrb(2) = '1')then
	   cc_rst <= '0';
	 end if;
	 cntrb <= cntrb + 1;
	 strobe <= not strobe;
  end if;
end process;
process(l_clk)
begin
  if(l_clk'event and l_clk = '1')then
		if(div = "110")then
			div <= "000";
			l_strobe <= '1';
		else
			div <= div + 1;
			l_strobe <= '0';
		end if;
		if(strobe = '1')then
			cntr <= cntr + 1;
		end if;
  end if;
end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for 100ms;	

      wait for l_clk_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
